#define ClipRect			{										\
							if (!Bits)	return;						\
							if (y0<0)	{							\
								h-=0-y0;							\
								y0=0;								\
							}										\
							if (x0<0)	{							\
								l+=0+x0;							\
								x0=0;								\
							}										\
							y0+=CLIP_Y0;							\
							x0+=CLIP_X0;							\
							if (y0+h>=CLIP_Y1)	{					\
								h+=CLIP_Y1-(y0+h);					\
							}										\
							if (x0+l>=CLIP_X1)	{					\
								l+=CLIP_X1-(x0+l);					\
							}										\
							if (h<0)	return;						\
							}

void ColoreCadre(int x0, int y0, int l, int h, int couleur)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;
	register unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;

	ClipRect;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			*(ptr++)=bleu;
			*(ptr++)=vert;
			*(ptr++)=rouge;
		}
	}
}

void AdditionneCadre(int x0, int y0, int l, int h, int couleur)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;

	ClipRect;
	
	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*ptr>=255-bleu)			*ptr=255;
			else						*ptr+=bleu;
			ptr++;
			if (*ptr>=255-vert)			*ptr=255;
			else						*ptr+=vert;
			ptr++;
			if (*ptr>=255-rouge)		*ptr=255;
			else						*ptr+=rouge;
			ptr++;
		}
	}
}

void SoustraitCadre(int x0, int y0, int l, int h, int couleur)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;

	ClipRect;
	
	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*ptr<=bleu)				*ptr=0;
			else						*ptr-=bleu;
			ptr++;
			if (*ptr<=vert)				*ptr=0;
			else						*ptr-=vert;
			ptr++;
			if (*ptr<=rouge)			*ptr=0;
			else						*ptr-=rouge;
			ptr++;
		}
	}
}

void MasqueCadre(int x0, int y0, int l, int h, int couleur, register int niveau)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;

	ClipRect;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (bleu)
				*ptr=(bleu*niveau-(niveau-255)*(*ptr))/255;
			ptr++;
			if (vert)
				*ptr=(vert*niveau-(niveau-255)*(*ptr))/255;
			ptr++;
			if (rouge)
				*ptr=(rouge*niveau-(niveau-255)*(*ptr))/255;
			ptr++;
		}
	}
}

void TransCadre(int x0, int y0, int l, int h, int couleur, register unsigned char niveau)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;
	int nv=niveau-255, factb=bleu*niveau, factv=vert*niveau, factr=rouge*niveau;

	ClipRect;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			*ptr=(factb-nv*(*ptr))/255;
			ptr++;
			*ptr=(factv-nv*(*ptr))/255;
			ptr++;
			*ptr=(factr-nv*(*ptr))/255;
			ptr++;
		}
	}
}

void InverseCadre(int x0, int y0, int l, int h)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;

	ClipRect;
	
	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			*ptr^=0xff;
			ptr++;
			*ptr^=0xff;
			ptr++;
			*ptr^=0xff;
			ptr++;
		}
	}
}
