#define SECTION_CRITIQUE		{	CRITICAL_SECTION _cs;	InitializeCriticalSection(&_cs);	EnterCriticalSection(&_cs);
#define FIN_CRITIQUE			LeaveCriticalSection(&_cs);	DeleteCriticalSection(&_cs);	}

#define DessTexte(x,y,texte)	TextOut(hdcImage,x+CLIP_X0,y+CLIP_Y0,texte,strlen(texte))
#define ModeTexte(mode)			SetBkMode(hdcImage,mode)
#define CouleurTexte(coul)		SetTextColor(hdcImage,coul)

void ChangeFonte(const char *police, int taille)		{
	if (fonteCourante)
		DeleteObject(fonteCourante);

	logFCour.lfHeight=taille;
	logFCour.lfWidth=0;
	logFCour.lfEscapement=0;

	logFCour.lfCharSet=ANSI_CHARSET;
	logFCour.lfOutPrecision=0;
	logFCour.lfClipPrecision=0;
	logFCour.lfQuality=0;
	logFCour.lfPitchAndFamily=FF_DONTCARE;
	strcpy(logFCour.lfFaceName,police);

	fonteCourante=CreateFontIndirect(&logFCour);
	SelectObject(hdcImage,fonteCourante);
}

#define GRAS 1,0,0,0,0
#define NORMAL 0,0,0,0,0
#define ITALIQUE 0,1,0,0,0
#define SOULIGNE 0,0,1,0,0
#define GRAS_ITALIQUE 1,1,0,0,0

void AttributsTexte(int gras, int italique, int souligne, int barre, int angle)		{
	logFCour.lfEscapement=angle;
	logFCour.lfWeight=gras?FW_BOLD:FW_NORMAL;
	logFCour.lfItalic=italique;
	logFCour.lfUnderline=souligne;
	logFCour.lfStrikeOut=barre;
	if (fonteCourante)
		DeleteObject(fonteCourante);
	fonteCourante=CreateFontIndirect(&logFCour);
	SelectObject(hdcImage,fonteCourante);
}

